
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class SubscriptionsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const subscriptions = await db.subscriptions.create(
            {
                id: data.id || undefined,
        
        provider_reference: data.provider_reference
        ||
        null
            ,
            
        status: data.status
        ||
        null
            ,
            
        current_period_start_at: data.current_period_start_at
        ||
        null
            ,
            
        current_period_end_at: data.current_period_end_at
        ||
        null
            ,
            
        cancelled_at: data.cancelled_at
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await subscriptions.setOrganization(currentUser.organization.id || null, {
            transaction,
        });
        
        await subscriptions.setCustomer( data.customer || null, {
            transaction,
        });
        
        await subscriptions.setService_package( data.service_package || null, {
            transaction,
        });
        

        

        

        return subscriptions;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const subscriptionsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                provider_reference: item.provider_reference
            ||
            null
            ,
            
                status: item.status
            ||
            null
            ,
            
                current_period_start_at: item.current_period_start_at
            ||
            null
            ,
            
                current_period_end_at: item.current_period_end_at
            ||
            null
            ,
            
                cancelled_at: item.cancelled_at
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const subscriptions = await db.subscriptions.bulkCreate(subscriptionsData, { transaction });

        // For each item created, replace relation files
        

        return subscriptions;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const subscriptions = await db.subscriptions.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.provider_reference !== undefined) updatePayload.provider_reference = data.provider_reference;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        if (data.current_period_start_at !== undefined) updatePayload.current_period_start_at = data.current_period_start_at;
        
        
        if (data.current_period_end_at !== undefined) updatePayload.current_period_end_at = data.current_period_end_at;
        
        
        if (data.cancelled_at !== undefined) updatePayload.cancelled_at = data.cancelled_at;
        
        
        updatePayload.updatedById = currentUser.id;

        await subscriptions.update(updatePayload, {transaction});

        
        
        if (data.organization !== undefined) {
            await subscriptions.setOrganization(
              
              (globalAccess ? data.organization : currentUser.organization.id),
              
              { transaction }
            );
        }
        
        if (data.customer !== undefined) {
            await subscriptions.setCustomer(
              
              data.customer,
              
              { transaction }
            );
        }
        
        if (data.service_package !== undefined) {
            await subscriptions.setService_package(
              
              data.service_package,
              
              { transaction }
            );
        }
        

        
        

        

        return subscriptions;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const subscriptions = await db.subscriptions.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of subscriptions) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of subscriptions) {
                await record.destroy({transaction});
            }
        });


        return subscriptions;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const subscriptions = await db.subscriptions.findByPk(id, options);

        await subscriptions.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await subscriptions.destroy({
            transaction
        });

        return subscriptions;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const subscriptions = await db.subscriptions.findOne(
            { where },
            { transaction },
        );

        if (!subscriptions) {
            return subscriptions;
        }

        const output = subscriptions.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.organization = await subscriptions.getOrganization({
            transaction
        });
        
        
        output.customer = await subscriptions.getCustomer({
            transaction
        });
        
        
        output.service_package = await subscriptions.getService_package({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.organizations,
        as: 'organization',
        
      },

      {
        model: db.customers,
        as: 'customer',
        
        where: filter.customer ? {
          [Op.or]: [
            { id: { [Op.in]: filter.customer.split('|').map(term => Utils.uuid(term)) } },
            {
              full_name: {
                [Op.or]: filter.customer.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.service_packages,
        as: 'service_package',
        
        where: filter.service_package ? {
          [Op.or]: [
            { id: { [Op.in]: filter.service_package.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.service_package.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.provider_reference) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'subscriptions',
                        'provider_reference',
                        filter.provider_reference,
                    ),
                };
            }
            

            
            

            
            if (filter.current_period_start_atRange) {
                const [start, end] = filter.current_period_start_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    current_period_start_at: {
                    ...where.current_period_start_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    current_period_start_at: {
                    ...where.current_period_start_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.current_period_end_atRange) {
                const [start, end] = filter.current_period_end_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    current_period_end_at: {
                    ...where.current_period_end_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    current_period_end_at: {
                    ...where.current_period_end_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.cancelled_atRange) {
                const [start, end] = filter.cancelled_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    cancelled_at: {
                    ...where.cancelled_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    cancelled_at: {
                    ...where.cancelled_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            


      
      if (filter.organization) {
        const listItems = filter.organization.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationId: {[Op.or]: listItems}
        };
      }
      

      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.subscriptions.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'subscriptions',
                        'provider_reference',
                        query,
                    ),
                ],
            };
        }

        const records = await db.subscriptions.findAll({
            attributes: [ 'id', 'provider_reference' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['provider_reference', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.provider_reference,
        }));
    }

    
};

